Subject: datum->syntax chokes on lists of syntax objects

From: [email-masked] (Taylan Ulrich Bayırlı/Kammer)
Date: Sun, 30 Aug 2015 10:31:09 +0200

Apparently there's two ways to represent a list syntax object:

    (datum->syntax #'x '(a b c))
    => #(syntax-object (a b c) ((top)) (hygiene guile-user))

i.e. a syntax object vector with a list payload, and

    #'(a b c)
    => (#(syntax-object a ((top)) (hygiene guile-user))
        #(syntax-object b ((top)) (hygiene guile-user))
        #(syntax-object c ((top)) (hygiene guile-user)))

i.e. a list of the elements as syntax objects.

Syntax-case and syntax->datum work fine with both.  But when the latter
form is used as the first argument to a datum->syntax call, it leads to
an error:

--- snip
scheme@(guile-user)> (datum->syntax #'(x) '(a b c))
ice-9/psyntax.scm:467:4: In procedure datum->syntax:
ice-9/psyntax.scm:467:4: In procedure vector-ref: Wrong type argument in position 1 (expecting vector): (#(syntax-object x ((top)) (hygiene guile-user)))

Entering a new prompt.  Type `,bt' for a backtrace or `,q' to continue.
scheme@(guile-user) [1]>
--- snip

I think I understand the problem: in case of a list of syntax objects,
it's ambiguous which one's environment should be used for the newly
created syntax object, so it requires it to be an "immediately wrapped"
syntax object instead.  (By the way, the psyntax sources actually call
that argument 'id', hinting that perhaps it's expected to be an
identifier, though the other representation works fine.)

I have no clue what's the best way to solve this, but if my
understanding is correct, it's a fundamental issue with datum->syntax
and not a bug, so here's a documentation patch that tries to explain the
limitation.

>From 9578ee36ef005f0b96c1d5b120f11c178e341775 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Taylan=20Ulrich=20Bay=C4=B1rl=C4=B1/Kammer?=
 <[email-masked]>
Date: Sun, 30 Aug 2015 10:24:52 +0200
Subject: [PATCH] Amend datum->syntax documentation.

* doc/ref/api-macros.texi (Syntax Case): Mention that the first argument
  to datum->syntax is invalid if it's a compound syntax object, except
  when also created with datum->syntax.
---
 doc/ref/api-macros.texi | 7 ++++++-
 1 file changed, 6 insertions(+), 1 deletion(-)

diff --git a/doc/ref/api-macros.texi b/doc/ref/api-macros.texi
index c2910a4..9c1f023 100644
--- a/doc/ref/api-macros.texi
+++ b/doc/ref/api-macros.texi
@@ -618,7 +618,12 @@ But they can, if we explicitly introduce a binding via @code{datum->syntax}.
 
 @deffn {Scheme Procedure} datum->syntax for-syntax datum
 Create a syntax object that wraps @var{datum}, within the lexical context
-corresponding to the syntax object @var{for-syntax}.
+corresponding to the syntax object @var{for-syntax}.  @var{for-syntax} must
+either be an identifier, or a syntax object that was also created with
+@var{datum->syntax}; other compound syntax objects may be rejected because they
+contain identifiers from different lexical contexts, in which case it would be
+ambiguous which one's environment should be used for the newly created syntax
+object.
 @end deffn
 
 For completeness, we should mention that it is possible to strip the metadata
-- 
2.5.0